## xen 4.14.0+80-gd101b417b7

=== debian/changelog ===
xen (4.14.0+80-gd101b417b7-1) unstable; urgency=medium

  * Re-upload to unstable for rebuild.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 24 Nov 2020 10:28:22 +0000

xen (4.14.0+80-gd101b417b7-1~exp2) experimental; urgency=medium

  * Re-upload since apparently DMs aren't allowed NEW?

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 23 Nov 2020 13:24:17 +0000

xen (4.14.0+80-gd101b417b7-1~exp1) experimental; urgency=medium

  * Update to new upstream version 4.14.0+80-gd101b417b7, which also contains
    security fixes for the following issues:
    - Information leak via power sidechannel
      XSA-351 (no CVE yet)
    - x86 PV guest INVLPG-like flushes may leave stale TLB entries
      XSA-286 (no CVE yet)
    - unsafe AMD IOMMU page table updates
      XSA-347 (no CVE yet)
    - undue deferral of IOMMU TLB flushes
      XSA-346 (no CVE yet)
    - x86: Race condition in Xen mapping code
      XSA-345 (no CVE yet)
    - lack of preemption in evtchn_reset() / evtchn_destroy()
      XSA-344 CVE-2020-25601
    - races with evtchn_reset()
      XSA-343 CVE-2020-25599
    - out of bounds event channels available to 32-bit x86 domains
      XSA-342 CVE-2020-25600
    - Missing memory barriers when accessing/allocating an event channel
      XSA-340 CVE-2020-25603
    - x86 pv guest kernel DoS via SYSENTER
      XSA-339 CVE-2020-25596
    - once valid event channels may not turn invalid
      XSA-338 CVE-2020-25597
    - PCI passthrough code reading back hardware registers
      XSA-337 CVE-2020-25595
    - race when migrating timers between x86 HVM vCPU-s
      XSA-336 CVE-2020-25604
    - Missing unlock in XENMEM_acquire_resource error path
      XSA-334 CVE-2020-25598
    - x86 pv: Crash when handling guest access to MSR_MISC_ENABLE
      XSA-333 CVE-2020-25602
  * Updating to the most recent upstream stable-4.14 branch also fixes
    additional compiling issues with gcc 10 that we were running into. These
    were: upstream commit 5d45ecabe3c0 ("xen/arm64: force gcc 10+ to always
    inline generic atomics helpers") to fix a FTBFS at mem_access.c and
    upstream commit 0dfddb2116e3 ("tools/xenpmd: Fix gcc10 snprintf warning")
    to fix a FTBFS on armhf. (Closes: #970802)
  * Drop upstream commits d25cc3ec93eb ("libxl: workaround gcc 10.2
    maybe-uninitialized warning") and fff1b7f50e75 ("libxl: fix
    -Werror=stringop-truncation in libxl__prepare_sockaddr_un") from our patch
    pile because these gcc 10 related fixes are in the upstream stable branch
    now.
  * Partially revert "debian/rules: Combine shared Make args" since it caused
    a FTBFS on i386.
  * Revert upstream commit a516bddbd3 ("tools/firmware/Makefile:
    CONFIG_PV_SHIM: enable only on x86_64") and cherry-pick our previous
    commits 0b898ccc2 ("tools/firmware/Makfile: Respect caller's
    CONFIG_PV_SHIM") and a516bddbd3 ("tools/firmware/Makefile: CONFIG_PV_SHIM:
    enable only on x86_64") again to work around a FTBFS where the shim would
    not be built during the i386 package build.
  * Now all FTBFS issues should be resolved, so we can do (Closes: #968965)

  Packaging minor fixes and improvements:
  * d/xen-utils-common.xen.init: Actually *really* include the change to
    disable oom killer for xenstored. It inadvertently got lost in
    4.14.0-1~exp1. (Closes: #961511)

  Lintian related fixes:
  * debian/changelog: fix a typo in the previous changelog entry

 -- Hans van Kranenburg <hans@knorrie.org>  Sun, 22 Nov 2020 02:16:00 +0100

xen (4.14.0-1~exp1) experimental; urgency=medium

  Significant changes:
  * Update to new upstream version 4.14.0.
    (Closes: #866380) about removal of broken xen-bugtool
  * debian/{rules,control}: switch to python 3
    (Closes: #938843) about python 2 removal in bullseye
  * debian/control: Fix python dependency to use python3-dev:any and
    libpython3-dev  [Elliott Mitchell]

  Changes related to upgrading to Xen 4.14:
  * debian/control: adjust to 4.14
  * debian/rules: remove install commands for pkgconfig files, since those
    files are not present any more
  * debian/: Follow fsimage -> xenfsimage renaming
  * debian/xen-utils-V.*: Use @version@ instead of hardcoded version
  * debian/control: add flex, bison
  * debian/control: add libxenhypfs[1]  [Ian Jackson]
  * debian/libxenstore3.0.symbols: drop xprintf
    (Closes: #968965)  [Ian Jackson; also reported by Gianfranco Costamagna]
  * d/scripts/xen-init-name, d/scripts/xen-init-list: rewrite these two
    scripts, hugely simplify them and make them use python 3
  * Pick upstream commits d25cc3ec93eb ("libxl: workaround gcc 10.2
    maybe-uninitialized warning") and fff1b7f50e75 ("libxl: fix
    -Werror=stringop-truncation in libxl__prepare_sockaddr_un") to fix gcc 10
    FTBFS
  * tools: don't build/ship xenmon, it can't work with python 3

  Packaging minor fixes and improvements:
  * debian/rules: Set DEB_BUILD_MAINT_OPTIONS in shell
    (Closes: #939560)  [Ian Jackson; report from Guillem Jover]
  * debian/rules: Improve comment about hardening options
    (Closes: #939560)  [Ian Jackson; report from Guillem Jover]
  * debian/rules: Drop redundant sequence numbers in dh_installinit
    (Closes: #939560)  [Ian Jackson; report from Guillem Jover]
  * d/xen-utils-common.xen.init: add important notes to keep in mind when
    changing this script, related to multi-version handling
  * debian/control: cleanup Uploaders and add myself
  * debian/control: s/libncurses5-dev/libncurses-dev/
  * xen-utils-V scripts: remove update-alternatives command
  * xen-utils-V.postinst.vsn-in: whitespace cosmetics
  * d/xen-utils-common.xen.init: disable oom killer for xenstored
    (Closes: #961511)
  * debian/rules: Combine shared Make args  [Elliott Mitchell]

  Fixes and improvements for cross-compiling  [Elliott Mitchell]:
  * debian/rules: Add --host to tools configure target
  * Pick upstream commit 69953e285638 ('tools: Partially revert
    "Cross-compilation fixes."')

  Lintian related fixes:


=== debian/control ===
Source: xen
Priority: optional
Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
Uploaders: Ian Jackson <ian.jackson@eu.citrix.com>, Hans van Kranenburg <hans@knorrie.org>
Section: admin
Standards-Version: 4.5.0
Build-Depends:
   debhelper (>= 10),
   dh-exec,
   dpkg-dev (>= 1.16.0~),
   rdfind,
   lsb-release,
   flex, bison,
   python3-dev:any,
   libpython3-dev,
   dh-python,
   bcc [i386 amd64],
   gcc-multilib [i386 amd64],
   e2fslibs-dev,
   iasl,
   seabios (>= 1.7.4-2~) [i386 amd64],
   libaio-dev,
   libfdt-dev [armhf arm64],
   libglib2.0-dev,
   liblzma-dev,
   libncurses-dev,
   libpixman-1-dev,
   libyajl-dev,
   pkg-config,
   uuid-dev,
   zlib1g-dev,
   pandoc,
   markdown,
   ocaml-native-compilers | ocaml-nox,
   ocaml-findlib,
Homepage: https://xenproject.org/
Vcs-Browser: https://salsa.debian.org/xen-team/debian-xen
Vcs-Git: https://salsa.debian.org/xen-team/debian-xen.git

Package: xenstore-utils
Architecture: amd64 arm64 armhf i386
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: xen-utils-common (<= 4.11.1~pre+1.733450b39b-1~)
Breaks: xen-utils-common (<= 4.11.1~pre+1.733450b39b-1~)
Suggests: xen-doc
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See https://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Section: admin
Architecture: amd64 i386 armhf arm64
Depends: lsb-base, udev, xenstore-utils,
    ${shlibs:Depends}, ${python3:Depends}, ${misc:Depends}
Suggests: xen-doc
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-hypervisor-common
Section: kernel
Architecture: all
Depends: ${misc:Depends}
Replaces: xen-hypervisor-4.8-amd64, xen-hypervisor-4.8-arm64, xen-hypervisor-4.8-armhf
Description: Xen Hypervisor - common files
 The configuration which arranges for an installed hypervisor to be booted
 as default, with the right command line arguments passed to both
 hypervisor and host (Domain 0) kernel.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-doc
Section: doc
Architecture: amd64 i386 armhf arm64
Depends: ${misc:Depends}
Description: XEN documentation
 Documentation for the Xen hypervisor and surrounding software,
 including descriptions of the hypercall interfaces and of some
 of the library APIs.
 .
 You do not need this package for the primary manpages for the
 Xen control utilities, as those are in the xen-utils-common package.
# Yes, arch-specific.  See xen-doc.lintian-overrides.

Package: xen-utils-4.14
Section: admin
Architecture: amd64 arm64 armhf i386
Provides: xen-utils
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, xen-utils-common (>= ${source:Version})
Recommends: bridge-utils, libc6-xen [i386], xen-hypervisor-4.14, qemu-system-x86, grub-xen-host [i386 amd64]
Suggests: qemu-utils [i386 amd64], seabios [i386 amd64], ovmf
Description: XEN administrative tools
 The userspace tools to manage a system virtualized through the XEN virtual
 machine monitor.
 .
 qemu-utils and seabios are neded for "Xen HVM" (amd64 and i386)
Built-Using: ${misc:Built-Using}

Package: xen-hypervisor-4.14-amd64
Section: kernel
Architecture: amd64 i386
Provides: xen-hypervisor, xen-hypervisor-4.14, xen-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.14, xen-hypervisor-common
Description: Xen Hypervisor on AMD64
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-amd64
Section: admin
Architecture: amd64 i386
Provides: xen-system
Depends: xen-hypervisor-4.14-amd64, xen-hypervisor-common, xen-utils-4.14, ${misc:Depends}
Description: Xen System on AMD64 (metapackage)
 This package depends on the latest Xen hypervisor for use on AMD64 and the
 Xen utils.

Package: xen-hypervisor-4.14-arm64
Section: kernel
Architecture: arm64
Provides: xen-hypervisor, xen-hypervisor-4.14, xen-hypervisor-arm64
Depends: ${misc:Depends}
Recommends: xen-utils-4.14, xen-hypervisor-common
Description: Xen Hypervisor on ARM64
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-arm64
Section: admin
Architecture: arm64
Provides: xen-system
Depends: xen-hypervisor-4.14-arm64, xen-hypervisor-common, xen-utils-4.14, ${misc:Depends}
Description: Xen System on ARM64 (metapackage)
 This package depends on the latest Xen hypervisor for use on ARM64 and the
 Xen utils.

Package: xen-hypervisor-4.14-armhf
Section: kernel
Architecture: armhf
Provides: xen-hypervisor, xen-hypervisor-4.14, xen-hypervisor-armhf
Depends: ${misc:Depends}
Recommends: xen-utils-4.14, xen-hypervisor-common
Description: Xen Hypervisor on ARMHF
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-armhf
Section: admin
Architecture: armhf
Provides: xen-system
Depends: xen-hypervisor-4.14-armhf, xen-hypervisor-common, xen-utils-4.14, ${misc:Depends}
Description: Xen System on ARMHF (metapackage)
 This package depends on the latest Xen hypervisor for use on ARMHF and the
 Xen utils.

Package: libxen-dev
Section: libdevel
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends},
	 libxenmisc4.14 (= ${binary:Version}),
	 libxencall1 (= ${binary:Version}),
	 libxendevicemodel1 (= ${binary:Version}),
	 libxenevtchn1 (= ${binary:Version}),
	 libxenforeignmemory1 (= ${binary:Version}),
	 libxengnttab1 (= ${binary:Version}),
	 libxenstore3.0 (= ${binary:Version}),
	 libxentoolcore1 (= ${binary:Version}),
	 libxentoollog1 (= ${binary:Version}),
	 libxenhypfs1 (= ${binary:Version}),
Description: Public headers and libs for Xen
 This package contains the public headers and static libraries for Xen.
 .
 The libxenlight library is intended as a common base for all Xen toolstack
 developers.  The libxlutil library contains additional helpers which may
 be useful to toolstack developers.
 .
 The libxenstore library allows userspace processes to interact with
 the XenStore database.  Command line tools for accessing xenstore are
 provided is via the xenstore-utils package.
 .
 Most of the other included libraries are internal, and intended for
 use by the Xen toolstack, rather than directly.

Package: libxenmisc4.14
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - miscellaneous, versioned ABI
 Shared libraries for Xen utilities.
 This package contains libraries whose ABI changes with each
 new upstream Xen release, which include ones which embed
 knowledge of hypervisor-version-specific hypercall ABIs.
Multi-Arch: same

Package: libxencall1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxencall
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxendevicemodel1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxendevicemodel
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenevtchn1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenevtchn
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenforeignmemory1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenforeignmemory
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxengnttab1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxengnttab
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenstore3.0
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxenstore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoolcore1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoolcore
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxentoollog1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime libraries - libxentoollog
 Shared library for Xen utilities.
Multi-Arch: same

Package: libxenhypfs1
Section: libs
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xen runtime library - libxenhypfs
 Shared library for Xen utilities.
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL    := bash -e

# This influences dpkg-buildflags to specify better linker
# options.  See https://wiki.debian.org/Hardening
# Apparently some of these might incur silent breakage
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=939560#5
# but we don't think this is relevant to us.
#
# Note that we don't use the dpkg-buildflags output for the
# hypervisor build.  This because I haven't investigated which
# of them are sane to use in the hypervisor context, rather than
# simply in userland binaries.
#
# Inexplicably, if you tell make `export V=value' and `$(shell ...)'
# it does not pass V to the shell.  WTF.  So we set a variable
# dbmo which we include in the relevant $(shell ...) invocations.
dbmo= DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Architecture handling.
#
# We need to explicitly specify the architecture because the Xen
# upstream build system likes to use `uname' which can produce wrong
# answers it other-bitness chroots, and because we need to build a
# 64-bit hypervisor even on i386 (since there is no 32-bit hypervisor
# anymore).

# Also there is terminological confusion.  The DEB_* variables follow
# GNU GCC terminology:
#
# dpkg / GNU    Xen         Meaning
#  BUILD         COMPILE     Host: where this build is running
#  HOST          TARGET      Target: where the binaries we build now will run

include /usr/share/dpkg/architecture.mk

# Xen has its own different architecture names, which are nither
# Debian nor GNU names.

flavour_amd64 = amd64
flavour_i386  = amd64
flavour_armhf = armhf
flavour_arm64 = arm64

xen_arch_amd64 = x86_64
xen_arch_i386  = x86_32
xen_arch_armhf = arm32
xen_arch_arm64 = arm64

flavour=$(flavour_$(DEB_HOST_ARCH))

# Much of the work here is to make different upstream versions of Xen
# coinstallable, and arrange to run which ever version of the tools
# corresponds to the running hypervisor.
#
# This packaging produces one version.  The nominal upstream version
# represents the control ABI used by hypervisor management utilities.
#
# In this package that version number appears in (i) debian/control
# and (ii) the first two numbers in the package version in
# debian/changelog.  These must both be updated when a new major
# upstream version is packaged (eg 4.10 -> 4.11).
# (Everywhere else, it is handled dynamically.)
#
upstream_version := \
 $(shell dpkg-parsechangelog -SVersion | sed 's/\(\.[0-9]*\)\..*/\1/' )

# Many of the debhelper files are most conveniently provided as
# templates which depend on the flavour and the upstream version.
# Since even some package names depend on the version, so do some
# dh input filenames.  We support this as follows:
#
# These runes take all files named   debian/*.vsn-in
# and do these three things:
#  1. in the file contents
#    (a) substitute @version@ @flavour@
#    (b) interpret lines like
#		? flavour = <value> [ | <other-value> ...]
#		? flavour != <value> [ | <other-value> ...]
#     as conditional output lasting until the next ? on is own.
#  2. replace any V in the file *name* with that same version
#     and any F with the flavour
#  3. strip .vsn-in from the end
# The resulting files are then consumed by dh.
#
# (debhelper has a shell script control file facility, but that cannot
# handle the need to vary the actual filename seen by debhelper.)

TEMPLATE_FILES := $(wildcard debian/*.vsn-in)

define template_rule_template =
 TEMPLATED_FILES += $(2)
 $(2): $(1) debian/rules debian/changelog debian/template-subst
	debian/template-subst $(upstream_version) $(flavour) <$$< >$$@.tmp \
	&& mv -f $$@{.tmp,}
endef

$(foreach t,$(TEMPLATE_FILES), $(eval 					\
	$(call 								\
		template_rule_template, $t, 				\
		$(subst F,$(flavour),					\
		 $(subst V,$(upstream_version),				\
		  $(basename $t)					\
		 ))							\
	)))

templated-files: $(TEMPLATED_FILES)
	:

# Work around bug in dpkg-buildpackage: between dpkg 1.14.17 and 1.16.1
# it exports these.  This is a problem because we need to pass different
# options to the hypervisor build - the default options from dpkg
# et al are suitable for dom0 binaries but not for the hypervisor.
undefine CFLAGS
undefine CXXFLAGS
undefine FFLAGS
undefine CPPFLAGS
undefine LDFLAGS

# The Xen build system likes to download things at build-time.  We
# think we have disabled all of that with appropriate configure
# options.  But, set these too, so we spot if we miss any.
export WGET=/bin/false GIT=/bin/false

# Other build flags etc.

t=$(CURDIR)/debian/tmp

dpkg_CFLAGS   := $(shell $(dbmo) dpkg-buildflags --get CFLAGS)
dpkg_CPPFLAGS := $(shell $(dbmo) dpkg-buildflags --get CPPFLAGS)
dpkg_LDFLAGS  := $(shell $(dbmo) dpkg-buildflags --get LDFLAGS)

make_args_common := \
	XEN_COMPILE_ARCH=$(xen_arch_$(DEB_BUILD_ARCH))

make_args_xen := $(make_args_common) \
	XEN_TARGET_ARCH=$(xen_arch_$(flavour))
# (Xen upstream does not offer a separate CPPFLAGS,
# so we pass those in CFLAGS.)

make_args_tools := $(make_args_common) \
	XEN_TARGET_ARCH=$(xen_arch_$(DEB_HOST_ARCH)) \
	EXTRA_CFLAGS_XEN_TOOLS='$(dpkg_CFLAGS) $(dpkg_CPPFLAGS)' \
	PREPEND_LDFLAGS_XEN_TOOLS='$(dpkg_LDFLAGS)'

export PYBUILD_NAME=xen
export PYBUILD_DISABLE=test
export PYBUILD_SYSTEM=distutils

%:
	dh $@ --with=python3 --buildsystem=pybuild

# Without this, something on stretch passes CFLAGS in the environment
# to the Xen build system, which then (with 4.11) chokes printing
#   /bin/sh: 1: Syntax error: Unterminated quoted string
# probably because the CFLAGS value contains multiple options and
# therefore spaces.  See also the note by `undefine CFLAGS', above.
override_dh_auto_clean:
	rm -f debian/xen-tools-built.stamp
	$(MAKE) -j1 distclean

# To avoid that the build dirties the tree, our delta queue deletes
# config.sub and config.guess.  dh_update_autotools_config can get
# us fresh ones for each build, but it expects to find some there
# already with some weird properties.  Instead, just copy them
# from /usr/share/misc (which is where it gets them anyway)
override_dh_update_autotools_config:
	cp /usr/share/misc/{config.sub,config.guess} .

# Upstream has both a kconfig style configure for the hypervisor
# and autoconfery for the tools (what we call the `utils').
override_dh_auto_configure:
	cp debian/xen-kconfig xen/.config
	make -C xen olddefconfig $(make_args_xen)
	:
	$(make_args_tools) ./configure \
		--disable-stubdom \
		--prefix=/usr \
		--includedir=/usr/include \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-libexec-libdir-suffix=/$(DEB_HOST_MULTIARCH) \
		--host=$(DEB_HOST_MULTIARCH) \
		--mandir=/usr/share/man \
		--infodir=/usr/share/info \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--with-libexec-leaf-dir=xen-$(upstream_version) \
		--disable-blktap1 \
		--disable-blktap2 \
		--disable-qemu-traditional --disable-rombios \
		--with-system-qemu=/usr/bin/qemu-system-i386 \
		--enable-ovmf --with-system-ovmf=/usr/share/ovmf/OVMF.fd \
		--with-system-seabios=/usr/share/seabios/bios-256k.bin

# tools/firmware/xen-dir is the `shim' used for booting PV guests
# in an HVM container, for security (particularly, for meltdown/spectre
# mitigation).  It's actually a hypervisor.  On i386 it is not built
# by `make tools' because run that with XEN_COMPILE_ARCH=x86_32 which
# is no longer a supported hypervisor architecture.  And we want to
# build it with $(make_args_xen) not $(make_args_tools).  So do it
# separately.
override_dh_auto_build:
	$(MAKE) $(make_args_xen) xen
	$(MAKE) $(make_args_tools) tools docs CONFIG_PV_SHIM=n
	case $(flavour) in \
	amd64|i386) \
		$(MAKE) $(make_args_xen) -C tools/firmware/xen-dir ;; \
	esac
	touch debian/xen-tools-built.stamp

# We keep the amount of fixup and messing about with debian/tmp/
# to a minimum, because when working it is easier to rerun the
# later parts of the build than the whole of the two upstream make installs.
# However, there are three sets of fixes we must make:
override_dh_auto_install: $(TEMPLATED_FILES)

## xen 4.14.0+88

=== tools/libs/Makefile ===
XEN_ROOT = $(CURDIR)/../..
include $(XEN_ROOT)/tools/Rules.mk

SUBDIRS-y :=
SUBDIRS-y += toolcore
SUBDIRS-y += toollog
SUBDIRS-y += evtchn
SUBDIRS-y += gnttab
SUBDIRS-y += call
SUBDIRS-y += foreignmemory
SUBDIRS-y += devicemodel
SUBDIRS-y += hypfs

ifeq ($(CONFIG_RUMP),y)
SUBDIRS-y := toolcore
endif

all clean install distclean uninstall: %: subdirs-%

=== xen/common/Makefile ===
obj-$(CONFIG_ARGO) += argo.o
obj-y += bitmap.o
obj-y += bsearch.o
obj-$(CONFIG_HYPFS_CONFIG) += config_data.o
obj-$(CONFIG_CORE_PARKING) += core_parking.o
obj-y += cpu.o
obj-$(CONFIG_DEBUG_TRACE) += debugtrace.o
obj-$(CONFIG_HAS_DEVICE_TREE) += device_tree.o
obj-y += domctl.o
obj-y += domain.o
obj-y += event_2l.o
obj-y += event_channel.o
obj-y += event_fifo.o
obj-$(CONFIG_CRASH_DEBUG) += gdbstub.o
obj-$(CONFIG_GRANT_TABLE) += grant_table.o
obj-y += guestcopy.o
obj-bin-y += gunzip.init.o
obj-$(CONFIG_HYPFS) += hypfs.o
obj-y += irq.o
obj-y += kernel.o
obj-y += keyhandler.o
obj-$(CONFIG_KEXEC) += kexec.o
obj-$(CONFIG_KEXEC) += kimage.o
obj-y += lib.o
obj-$(CONFIG_NEEDS_LIST_SORT) += list_sort.o
obj-$(CONFIG_LIVEPATCH) += livepatch.o livepatch_elf.o
obj-$(CONFIG_MEM_ACCESS) += mem_access.o
obj-y += memory.o
obj-y += monitor.o
obj-y += multicall.o
obj-y += notifier.o
obj-y += page_alloc.o
obj-$(CONFIG_HAS_PDX) += pdx.o
obj-$(CONFIG_PERF_COUNTERS) += perfc.o
obj-y += preempt.o
obj-y += random.o
obj-y += rangeset.o
obj-y += radix-tree.o
obj-y += rbtree.o
obj-y += rcupdate.o
obj-y += rwlock.o
obj-y += shutdown.o
obj-y += softirq.o
obj-y += sort.o
obj-y += smp.o
obj-y += spinlock.o
obj-y += stop_machine.o
obj-y += string.o
obj-y += symbols.o
obj-y += sysctl.o
obj-y += tasklet.o
obj-y += time.o
obj-y += timer.o
obj-$(CONFIG_TRACEBUFFER) += trace.o
obj-y += version.o
obj-y += virtual_region.o
obj-y += vm_event.o
obj-y += vmap.o
obj-y += vsprintf.o
obj-y += wait.o
obj-bin-y += warning.init.o
obj-$(CONFIG_XENOPROF) += xenoprof.o
obj-y += xmalloc_tlsf.o

obj-bin-$(CONFIG_X86) += $(foreach n,decompress bunzip2 unxz unlzma lzo unlzo unlz4 earlycpio,$(n).init.o)

obj-$(CONFIG_COMPAT) += $(addprefix compat/,domain.o kernel.o memory.o multicall.o xlat.o)

extra-y := symbols-dummy.o

obj-$(CONFIG_COVERAGE) += coverage/
obj-y += sched/
obj-$(CONFIG_UBSAN) += ubsan/

obj-$(CONFIG_NEEDS_LIBELF) += libelf/
obj-$(CONFIG_HAS_DEVICE_TREE) += libfdt/

CONF_FILE := $(if $(patsubst /%,,$(KCONFIG_CONFIG)),$(XEN_ROOT)/xen/)$(KCONFIG_CONFIG)
config.gz: $(CONF_FILE)
	gzip -c $< >$@

config_data.o: config.gz

config_data.S: $(XEN_ROOT)/xen/tools/binfile
	$(SHELL) $(XEN_ROOT)/xen/tools/binfile $@ config.gz xen_config_data

clean::
	rm -f config_data.S config.gz 2>/dev/null

=== tools/tests/xenstore/Makefile ===
XEN_ROOT=$(CURDIR)/../../..
include $(XEN_ROOT)/tools/Rules.mk

CFLAGS += -Werror

CFLAGS += $(CFLAGS_libxenstore)

TARGETS-y := xs-test
TARGETS := $(TARGETS-y)

.PHONY: all
all: build

.PHONY: build
build: $(TARGETS)

.PHONY: clean
clean:
	$(RM) *.o $(TARGETS) *~ $(DEPS_RM)

.PHONY: distclean
distclean: clean

xs-test: xs-test.o Makefile
	$(CC) -o $@ $< $(LDFLAGS) $(LDLIBS_libxenstore)

install uninstall:

-include $(DEPS_INCLUDE)

=== xen/xsm/flask/Makefile ===
obj-y += avc.o
obj-y += hooks.o
obj-y += flask_op.o

obj-y += ss/

CFLAGS-y += -I./include

AWK = awk

CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
          else if [ -x /bin/bash ]; then echo /bin/bash; \
          else echo sh; fi ; fi)

FLASK_H_DEPEND = policy/security_classes policy/initial_sids
AV_H_DEPEND = policy/access_vectors

FLASK_H_FILES = include/flask.h include/class_to_string.h include/initial_sid_to_string.h
AV_H_FILES = include/av_perm_to_string.h include/av_permissions.h
ALL_H_FILES = $(FLASK_H_FILES) $(AV_H_FILES)

$(obj-y) ss/built_in.o: $(ALL_H_FILES)
extra-y += $(ALL_H_FILES)

mkflask := policy/mkflask.sh
quiet_cmd_mkflask = MKFLASK $@
cmd_mkflask = $(CONFIG_SHELL) $(mkflask) $(AWK) include $(FLASK_H_DEPEND)

$(subst include/,%/,$(FLASK_H_FILES)): $(FLASK_H_DEPEND) $(mkflask) FORCE
	$(call if_changed,mkflask)

mkaccess := policy/mkaccess_vector.sh
quiet_cmd_mkaccess = MKACCESS VECTOR $@
cmd_mkaccess = $(CONFIG_SHELL) $(mkaccess) $(AWK) $(AV_H_DEPEND)

$(subst include/,%/,$(AV_H_FILES)): $(AV_H_DEPEND) $(mkaccess) FORCE
	$(call if_changed,mkaccess)

obj-bin-$(CONFIG_XSM_FLASK_POLICY) += flask-policy.o
flask-policy.o: policy.bin

flask-policy.S: $(XEN_ROOT)/xen/tools/binfile
	$(SHELL) $(XEN_ROOT)/xen/tools/binfile -i $@ policy.bin xsm_flask_init_policy

FLASK_BUILD_DIR := $(CURDIR)
POLICY_SRC := $(FLASK_BUILD_DIR)/xenpolicy-$(XEN_FULLVERSION)

policy.bin: FORCE
	$(MAKE) -f $(XEN_ROOT)/tools/flask/policy/Makefile.common -C $(XEN_ROOT)/tools/flask/policy FLASK_BUILD_DIR=$(FLASK_BUILD_DIR)
	cmp -s $(POLICY_SRC) $@ || cp $(POLICY_SRC) $@

.PHONY: clean
clean::
	rm -f $(ALL_H_FILES) *.o $(DEPS_RM) policy.* $(POLICY_SRC) flask-policy.S

## xen 4.14.0+88-g1d1d1f5391

=== debian/changelog ===
xen (4.14.0+88-g1d1d1f5391-2) unstable; urgency=high

  * For now, revert "debian/rules: Set CC/LD to enable cross-building", since
    it causes an FTBFS on i386.

 -- Hans van Kranenburg <hans@knorrie.org>  Tue, 15 Dec 2020 14:57:41 +0100

xen (4.14.0+88-g1d1d1f5391-1) unstable; urgency=high

  * Update to new upstream version 4.14.0+88-g1d1d1f5391, which also contains
    security fixes for the following issues:
    - stack corruption from XSA-346 change
      XSA-355 CVE-2020-29040 (Closes: #976109)
  * Apply security fixes for the following issues:
    - oxenstored: permissions not checked on root node
      XSA-353 CVE-2020-29479
    - xenstore watch notifications lacking permission checks
      XSA-115 CVE-2020-29480
    - Xenstore: new domains inheriting existing node permissions
      XSA-322 CVE-2020-29481
    - Xenstore: wrong path length check
      XSA-323 CVE-2020-29482
    - Xenstore: guests can crash xenstored via watchs
      XSA-324 CVE-2020-29484
    - Xenstore: guests can disturb domain cleanup
      XSA-325 CVE-2020-29483
    - oxenstored memory leak in reset_watches
      XSA-330 CVE-2020-29485
    - oxenstored: node ownership can be changed by unprivileged clients
      XSA-352 CVE-2020-29486
    - undue recursion in x86 HVM context switch code
      XSA-348 CVE-2020-29566
    - infinite loop when cleaning up IRQ vectors
      XSA-356 CVE-2020-29567
    - FIFO event channels control block related ordering
      XSA-358 CVE-2020-29570
    - FIFO event channels control structure ordering
      XSA-359 CVE-2020-29571
  * Note that the following XSA are not listed, because...
    - XSA-349 and XSA-350 have patches for the Linux kernel
    - XSA-354 has patches for the XAPI toolstack

  Packaging bugfixes and improvements:
  * d/rules: do not compress /usr/share/doc/xen/html (Closes: #942611)
  * Add missing CVE numbers to the previous changelog entries

  Packaging bugfixes and improvements [Elliott Mitchell]:
  * d/shuffle-binaries: Make error detection/message overt
  * d/shuffle-binaries: Add quoting for potentially changeable variables
  * d/shuffle-boot-files: Add lots of double-quotes when handling variables
  * debian/rules: Set CC/LD to enable cross-building
  * debian/xen.init: Load xen_acpi_processor on boot
  * d/shuffle-binaries: Remove useless extra argument being passed in

  Packaging bugfixes and improvements [Maximilian Engelhardt]:
  * d/xen-hypervisor-V-F.postinst.vsn-in: use reboot-required
    (Closes: #862408)
  * d/xen-hypervisor-V-F.postrm: actually install script
  * d/xen-hypervisor-V.*: clean up unused files
  * d/xen-hypervisor-V.bug-control.vsn-in: actually install script
  * debian/rules: enable verbose build

  Fixes to patches for upstream code:
  * t/h/L/vif-common.sh: force handle_iptable return value to be 0
    (Closes: #955994)

  * Pick the following upstream commits to improve Raspberry Pi 4 support,
    requested by Elliott Mitchell:
    - 25849c8b16 ("xen/rpi4: implement watchdog-based reset")
    - 17d192e023 ("tools/python: Pass linker to Python build process")
    - 861f0c1109 ("xen/arm: acpi: Don't fail if SPCR table is absent")
    - 1c4aa69ca1 ("xen/acpi: Rework acpi_os_map_memory() and
                   acpi_os_unmap_memory()")
    - 4d625ff3c3 ("xen/arm: acpi: The fixmap area should always be cleared
                   during failure/unmap")
    - dac867bf9a ("xen/arm: Check if the platform is not using ACPI before
                   initializing Dom0less")
    - 9c2bc0f24b ("xen/arm: Introduce fw_unreserved_regions() and use it")
    - 7056f2f89f ("xen/arm: acpi: add BAD_MADT_GICC_ENTRY() macro")
    - 957708c2d1 ("xen/arm: traps: Don't panic when receiving an unknown debug
                   trap")

  * Pick upstream commit ba6e78f0db ("fix spelling errors"). Thanks, Diederik.

 -- Hans van Kranenburg <hans@knorrie.org>  Tue, 15 Dec 2020 13:00:00 +0100

=== debian/rules ===
--- 
+++ 
@@ -135,7 +135,8 @@
 dpkg_LDFLAGS  := $(shell $(dbmo) dpkg-buildflags --get LDFLAGS)
 
 make_args_common := \
-	XEN_COMPILE_ARCH=$(xen_arch_$(DEB_BUILD_ARCH))
+	XEN_COMPILE_ARCH=$(xen_arch_$(DEB_BUILD_ARCH)) \
+	V=1
 
 make_args_xen := $(make_args_common) \
 	XEN_TARGET_ARCH=$(xen_arch_$(flavour))
@@ -216,4 +217,3 @@
 # to a minimum, because when working it is easier to rerun the
 # later parts of the build than the whole of the two upstream make installs.
 # However, there are three sets of fixes we must make:
-override_dh_auto_install: $(TEMPLATED_FILES)

## xen 4.14.1

=== debian/changelog ===
xen (4.14.1-5+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Tue, 08 Jun 2021 21:16:15 +0200

xen (4.14.1-5) unstable; urgency=medium

  * Apply XSA-373, XSA-375, XSA-377

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 08 Jun 2021 21:16:15 +0200

xen (4.14.1-4) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Apply HPET patches to handle both Intel and AMD systems

  [ Dmitry Fedorov ]
  * winusb: Apply a user defined max_maptrack_frames value to dm_config
    in the same way as for max_grant_frames
  * winusb: update patch to xen-4.14.1

  [ Demi Marie Obenour ]
  * Switch from wget to curl

  [ Marek Marczykowski-Górecki ]
  * makefile: handle CentOS 8 Stream

  [ Nedyalko Andreev ]
  * Add a patch with gcc11 fixes

  [ Marek Marczykowski-Górecki ]
  * Fix build on CentOS Stream 8

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 03 Jun 2021 04:54:50 +0200

xen (4.14.1-3) unstable; urgency=medium

  * Backport guest resume fix (libxl)
  * Backport HPET fix for recent Intel systems

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 20 Feb 2021 17:10:14 +0100

xen (4.14.1-2) unstable; urgency=medium

  * Add a patch for conditional IOMMU-less passthrough on PV domain

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 17 Jan 2021 13:25:01 +0100

xen (4.14.1-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Cleanup parent xenstore dir after device remove
  * archlinux: use autoreconf --install

  [ icequbes1 ]
  * archlinux: fix autoreconf fail on autoconf 2.70

  [ Trammell hudson ]
  * unified-xen: backport unified EFI loader from xen-staging

  [ Demi Marie Obenour ]
  * Mass replace: ‘/var/run’ → ‘/run’

  [ Marek Marczykowski-Górecki ]
  * Drop patches already applied in 4.14.1

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 05 Jan 2021 21:09:48 +0100

xen (4.14.0-9) unstable; urgency=medium

  * Apply XSA-115 and XSA-325 fixes

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 15 Dec 2020 13:25:53 +0100

xen (4.14.0-8) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Refactor Makefile
  * Add patches for improving reproducibility
  * Disable pvshim
  * spec: fix indentations for make docs
  * Reenable build id as it's computed on reproducible content
  * Add .gitlab-ci.yml

  [ Marek Marczykowski-Górecki ]
  * Apply XSA-355 patch

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 24 Nov 2020 13:25:18 +0100
